package z

import (
	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/cpu"
)

func (f *Compiler) RegisterLabel(mnemonic asm.Mnemonic, register cpu.Register, label string) {
	if f.CurrentScope().IsUsed(register) && isDestructive(mnemonic) {
		f.SaveRegister(register)
	}

	f.Assembler.RegisterLabel(mnemonic, register, label)

	if mnemonic == asm.MOVE {
		f.CurrentScope().Use(register)
	}

	f.postInstruction()
}
